local Color = require('classic'):extend()

function Color:new(r, g, b, a)
    if type(r) == "table" then
        self.r = r.r or 1
        self.g = r.g or 1
        self.b = r.b or 1
        self.a = r.a or 1

    else
        self.r = r or 1
        self.g = g or 1
        self.b = b or 1
        self.a = a or 1
        
    end

end

function Color:__mul(color)
    local r, g, b, a

    if type(color) == "table" then
        r = self.r * color.r
        g = self.g * color.g
        b = self.b * color.b
        a = self.a * color.a

    else
        r = self.r * color
        g = self.g * color
        b = self.b * color
        a = self.a * color

    end

    return Color(r, g, b, a)
end

function Color:__add(color)
    local r, g, b

    if type(color) == "table" then
        r = self.r + color.r
        g = self.g + color.g
        b = self.b + color.b
        a = self.a + color.a

    else
        color = tonumber(color)
        
        r = self.r + color
        g = self.g + color
        b = self.b + color
        a = self.a + color

    end

    return Color(r, g, b)
end

function Color:getBrightness()
    return 0.2126 * self.r + 0.7152 * self.g + 0.0722 * self.b
end

function Color:toNumbers()
    return {self.r, self.g, self.b, self.a}
end

return Color