hmath = {}

function hmath.toScreen(x, y)
    local xx = (xorigin * TILE_WIDTH) + (x - y) * (TILE_WIDTH / 2)
    local yy = (yorigin * TILE_HEIGHT) + (x + y) * (TILE_HEIGHT / 2)

    return math.floor(xx), math.floor(yy)
end

function hmath.getIndexFromXY(x, y, width)
    return y * width + x
end

local function sign(p1, p2, p3)
    return (p1[1] - p3[1]) * (p2[2] - p3[2]) - (p2[1] - p3[1]) * (p1[2] - p3[2])
end

function hmath.isPointOnTriangle(p, p1, p2, p3) -- https://stackoverflow.com/questions/2049582/how-to-determine-if-a-point-is-in-a-2d-triangle
    local d1, d2, d3
    local has_neg, has_pos

    d1 = sign(p, p1, p2)
    d2 = sign(p, p2, p3)
    d3 = sign(p, p3, p1)

    has_neg = (d1 < 0) or (d2 < 0) or (d3 < 0)
    has_pos = (d1 > 0) or (d2 > 0) or (d3 > 0)

    return not (has_neg and has_pos)
end

function hmath.getXYFromIndex(i, width)
    local x = math.floor((i - 1) % width) + 1
    local y = math.floor((i - x) / width) + 1

    return x, y
end

function hmath.normalize(x, min, max)
    return (x - min) / (max - min)
end

return hmath