local mouse = {}

local mousex, mousey
local cellx, celly
local tilex, tiley -- cellx * TILE_WIDTH, celly * TILE_HEIGHT
local xselected, yselected

local get_mouse = true

local cell_draw
local img

local function rawMouseInput()
    mousex, mousey = love.mouse.getPosition()
end

local function calculateDiagonalPosition()

    if hmath.isPointOnTriangle( -- top left
        { mousex / SCALE, mousey / SCALE },
        { tilex, tiley },
        { tilex + (TILE_WIDTH / 2), tiley },
        { tilex, tiley + (TILE_HEIGHT / 2) }
    ) then
        return -1, 0

    elseif hmath.isPointOnTriangle( -- top right
        { mousex / SCALE, mousey / SCALE },
        {tilex + (TILE_WIDTH / 2), tiley},
        {tilex + TILE_WIDTH, tiley},
        {tilex + TILE_WIDTH, tiley + (TILE_HEIGHT / 2)}
    ) then
        return 0, -1

    elseif hmath.isPointOnTriangle( -- bottom right
        { mousex / SCALE, mousey / SCALE },
        {tilex + TILE_WIDTH, tiley + (TILE_HEIGHT / 2)},
        {tilex + TILE_WIDTH, tiley + TILE_HEIGHT},
        {tilex + (TILE_WIDTH / 2), tiley + TILE_HEIGHT}
    ) then
        return 1, 0

    elseif hmath.isPointOnTriangle( -- bottom left
        { mousex / SCALE, mousey / SCALE },
        {tilex, tiley + (TILE_HEIGHT / 2)},
        {tilex, tiley + TILE_HEIGHT},
        {tilex + (TILE_WIDTH / 2), tiley + TILE_HEIGHT}
    ) then
        return 0, 1

    end

    return 0, 0
end

local function getCell()
    cellx = math.floor(mousex / TILE_WIDTH / SCALE)
    celly = math.floor(mousey / TILE_HEIGHT / SCALE)

    tilex = cellx * TILE_WIDTH
    tiley = celly * TILE_HEIGHT
end

local function getSelected()
    xselected = (celly - yorigin) + (cellx - xorigin)
    yselected = (celly - yorigin) - (cellx - xorigin)
    
    local xoff, yoff = calculateDiagonalPosition()

    xselected = xselected + xoff
    yselected = yselected + yoff
end

function mouse.load()
    img = love.graphics.newImage('tilesheet.png')
    cell_draw = love.graphics.newQuad(TILE_WIDTH * 9, TILE_HEIGHT * 4, TILE_WIDTH, TILE_HEIGHT * 2, img)
end

function mouse.update()
    if get_mouse then
        rawMouseInput()
        getCell()
        getSelected()
    end
end

function mouse.draw()
    if get_mouse then
        love.graphics.setColor(1, 1, 1)
        love.graphics.draw(img, cell_draw, hmath.toScreen(xselected, yselected))
    end
end

return mouse