local World = require('classic'):extend()

local loader        = require('world.world_loader')
local lighting      = require('world.world_lighting')
local LightSource = require("utils.LightSource")
local Color = require("utils.Color")

function World:new(tilemap, tilesheet)
    self.width = 0
    self.height = 0

    self.light_sources = {}
    self.world = {}

    self.tilehseet = tilesheet
    self.tilemap = {}

    loader.loadTileMap(self, tilemap)
    loader.loadTileSheet(self, tilesheet)

    -- lighting.addLighting(self, LightSource(2, 2, nil, 4))   
    
    lighting.addLighting(self, LightSource(5, 5, nil, 8))
    lighting.addLighting(self, LightSource(20, 5, nil, 8))
    
end

function World:draw()
    for y = 1, self.height do
		for x = 1, self.width do
			local tile_index = hmath.getIndexFromXY(x - 1, y - 1, self.width)
			local tile = self.world[tile_index]

			if not self.tilemap[tile.tileset] then
				goto continue
			end

			light_color = tile.light_level

			love.graphics.setColor(light_color:toNumbers())

            local xx, yy = hmath.toScreen(x, y)
			love.graphics.draw(self.tilesheet, self.tilemap[tile.tileset], xx, yy)

			::continue::
		end
	end
end

function World:update()
    
end

return World