local Tile          = require("world.Tile")
local Color         = require("utils.Color")
local LightSource   = require("utils.LightSource")

local loader = {
    tilemap_dir = 'tilemaps.'
}

-- TODO
--[[
    Add support for loading lighting
]]
function loader.loadTileMap(self, tilemap)
    local map = require(loader.tilemap_dir .. tilemap).layers[1]
    self.width = map.width
    self.height = map.height
    self.size = self.width * self.height

    local tile
    for y = 1, self.height do
        for x = 1, self.width do
            tile = Tile(map.data[hmath.getIndexFromXY(x, y - 1, self.width)], Color(LightSource.ambient))
            table.insert(self.world, hmath.getIndexFromXY(x - 1, y - 1, self.width), tile)
        end
    end

    -- self:addLightSource(LightSource(5, 5, nil, Color(), 8))
    -- self:addLightSource(LightSource(20, 5, nil, Color(), 8))
end

function loader.loadTileSheet(self, tilesheet)
    local sheet = love.graphics.newImage(tilesheet)
	local width = sheet:getWidth() / TILE_WIDTH
    local height = sheet:getHeight() / (TILE_HEIGHT * 2)
    
    for y = 1, height do
		for x = 1, width do
			local xx = x - 1
			local yy = y - 1

			table.insert(
				self.tilemap,
				(yy * width + xx) + 1,
				love.graphics.newQuad(xx * TILE_WIDTH, yy * (TILE_HEIGHT * 2),
					TILE_WIDTH, TILE_HEIGHT * 2,
					sheet:getWidth(), sheet:getHeight()
				)
			)
		end
	end

    self.tilesheet = sheet
end

return loader